// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;


//! A callback/functor class to perform range checks
/**
 * This class is an abstract base class. In order to use the range check
 * class, you need to derive a class from this (see CqLogRangeCheckCallback in ri.cpp)
 * The function call takes an argument which is the result of a CheckMinMax function call.
 *
 * l͈̓`FbÑR[obN̊NXBabstractNXƂĐ݌vĂB
 * ɁACheckMinMaxNXŗp͗lB
*/

public abstract strictfp class CqRangeCheckCallback {

	public abstract void valueAt( int res );
	
	public void Call( int res )
    {
        this.valueAt( res );
    }

	public final static int LOWER_BOUND_HIT = 0;
	public final static int UPPER_BOUND_HIT = 1;
	public final static int VALID = 2;
}
