// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

/**
 * Shader variable type identifier.
 * Any change to this MUST be mirrored in the type identifier and name string tables. 
 * 
 * @author NTT DATA Corporation
 */
public strictfp class EqVariableType {
	public final static int type_invalid = 0;
	
	public final static int type_float = 1;
	public final static int type_integer = 2;
	public final static int type_point = 3;
	public final static int type_string = 4;
	public final static int type_color = 5;
	public final static int type_triple = 6;
	public final static int type_hpoint = 7;
	public final static int type_normal = 8;
	public final static int type_vector = 9;
	public final static int type_void = 10;
	public final static int type_matrix = 11;
	public final static int type_sixteentuple = 12;
	public final static int type_bool = 13;

	public final static int type_last = 14;
    
	private int value;
	
	public EqVariableType(int value) {
		this.value = value;
	}
	public int getValue()
	{
		return value;
	}
	public void setValue(int val)
	{
		value = val;
	}

}
